[tox]
minversion = 3.10.0
envlist = py{39,310,311}-{flake8,unit,bandit,mypy,prospector,sphinx}
skip_missing_interpreters = True


[testenv]
usedevelop = True
download = True
whitelist_externals = sed
description =
    flake8: Style consistency checker
    unit: Run unit tests
    bandit: Security-oriented static analyzer
    mypy: Static analyzer for type annotations
    prospector: Static analysis multi-tool
    sphinx: Build documentation and manpages
    py39: (Python 3.9)
    py310: (Python 3.10)
    py311: (Python 3.11)
envdir =
    prospector: {toxworkdir}/{envname}
    py39-!prospector: {toxworkdir}/py39-tests
    py310-!prospector: {toxworkdir}/py310-tests
    py311-!prospector: {toxworkdir}/py311-tests
commands =
    flake8: flake8 setup.py gjson tests
    unit: py.test --strict-markers --cov-report=term-missing --cov=gjson tests/unit {posargs}
    # Skip some bandit issues:
    # - assert_used (B101) in tests
    bandit: bandit -l -i -r gjson/
    bandit: bandit -l -i -r --skip B101 tests/
    mypy: mypy --show-error-codes gjson/
    prospector: prospector --profile '{toxinidir}/prospector.yaml' {posargs} {toxinidir}
    sphinx: python setup.py build_sphinx -W -b html
    sphinx: python setup.py build_sphinx -W -b man
    # Fix missing space after bold blocks in man page: https://github.com/ribozz/sphinx-argparse/issues/80
    sphinx: sed -i='' -e 's/^\.B/.B /' '{toxinidir}/doc/build/man/gjson.1'
deps =
    # Use install_requires and the additional extras_require[tests/prospector] from setup.py
    prospector: .[prospector]
    !prospector: .[tests]


[flake8]
max-line-length = 120
statistics = True
ignore = W503
import-order-style = edited
application-import-names = gjson
